package CH.ifa.draw.application;

import java.io.*;
import java.net.*;
import java.util.*;
import de.renew.util.StringUtil;

public class DrawingLoadClient {

  public static void loadDrawings(String[] fileName) {
    int serverPort=1234;
    String serverPortStr=System.getProperty("de.renew.loadServerPort");
    if (serverPortStr!=null) {
	try {
	  serverPort=Integer.valueOf(serverPortStr).intValue();
	} catch (Exception e) {
	  System.out.println("No Drawing Load Server: "+e);
	}
    }
    // connect to the server:
    try {
      Socket s=new Socket("127.0.0.1",serverPort);
      PrintStream toSocket=new PrintStream(s.getOutputStream());
      for (int i=0; i<fileName.length; ++i) {
	toSocket.println(StringUtil.makeCanonical(fileName[i]));
      }
      toSocket.close();
      s.close();
    } catch (UnknownHostException e1) {
      System.out.println("localhost (127.0.0.1) not found. Please set up TCP/IP correctly.");
    } catch (IOException e2) {
      System.out.println("Probably the DrawingLoadServer is not running on port "+serverPort+"? Exception:\n"+e2);
    }
  }

  public static void main(String[] argc) {
    loadDrawings(argc);
  }

}
