/*
 * @(#)PolyLineHandle.java 5.1
 *
 */

package CH.ifa.draw.figures;

import java.awt.*;
import java.awt.event.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.util.Geom;

/**
 * A handle for a node on the polyline.
 */
public class InsertPointHandle extends PolyLineHandle {

   /**
    * Constructs a poly line handle.
    * @param owner the owning polyline figure.
    * @index the index of the node associated with this handle.
    */
    public InsertPointHandle(PolyLineFigure owner, int segment) {
        super(owner, new PolyLineSegmentLocator(segment), segment+1);
    }

    public void invokeStart(int  x, int  y, DrawingView view) {
	myOwner().insertPointAt(locate(),getIndex());
	view.selectionInvalidateHandles();
	super.invokeStart(x,y,view);
    }

    public void invokeStart(MouseEvent e, int  x, int  y, DrawingView view) {
	// switch off "delete" function on double-click
        invokeStart(x,y,view);
    }

    /**
     * Draws this handle.
     */
    public void draw(Graphics g) {
        Rectangle r = displayBox();

        g.setColor(Color.white);
        g.fillOval(r.x, r.y, r.width, r.height);

        g.setColor(Color.black);
        g.drawOval(r.x, r.y, r.width, r.height);

	// draw "+" into circle:
	Point mid=Geom.center(r);
        g.drawLine(r.x, mid.y, r.x+r.width, mid.y);
        g.drawLine(mid.x, r.y, mid.x, r.y+r.height);
    }

}


