/*
 * @(#)DuplicateCommand.java 5.1
 *
 */

package CH.ifa.draw.standard;

import java.util.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.framework.*;

/**
 * Duplicate the selection and select the duplicates.
 */
public class DuplicateCommand extends FigureTransferCommand {

   /**
    * Constructs a duplicate command.
    * @param name the command name
    * @param view the target view
    */
    public DuplicateCommand(String name, DrawingEditor editor) {
        super(name, editor);
    }

    public void execute() {
        DrawingView view = fEditor.view();

        FigureSelection selection = view.getFigureSelection();

        view.clearSelection();

        Vector figures = (Vector)selection.getData(FigureSelection.TYPE);
        insertFigures(figures, 10, 10);
        view.checkDamage();
    }

    public boolean isExecutable() {
        return fEditor.view().selectionCount() > 0;
    }

}


