/*
 * @(#)DrawingEditor.java 5.1
 *
 */

package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import java.awt.*;
import java.awt.event.*;

public class NullDrawingEditor implements DrawingEditor,
  java.awt.event.WindowListener
{
  public static NullDrawingEditor INSTANCE=new NullDrawingEditor();
  private NullDrawingEditor() {}

  public DrawingView view() {
    return NullDrawingView.INSTANCE;
  }
  public DrawingView previousView() {
    return NullDrawingView.INSTANCE;
  }
  public Drawing drawing() {
    return NullDrawing.INSTANCE;
  }
  public Tool tool() {
    return NullTool.INSTANCE;
  }
  public Tool defaultTool() { return null; }
  public void setStickyTools(boolean sticky) { }
  public boolean isStickyTools() { return false; }
  public Frame menuFrame() {
    // Hmm, is this correct?
    return null;
  }
  public void toolDone() {}
  public void selectionChanged(DrawingView view) {}
  public void showStatus(String string) {}
  public CH.ifa.draw.application.DrawingViewFrame
    showDrawingViewFrame(Drawing drawing)
  {
    // No such frame available.
    return null;
  }

  public void windowOpened(WindowEvent event) {}
  public void windowClosing(WindowEvent event) {}
  public void windowClosed(WindowEvent event) {}
  public void windowIconified(WindowEvent event) {}
  public void windowDeiconified(WindowEvent event) {}
  public void windowActivated(WindowEvent event) {}
  public void windowDeactivated(WindowEvent event) {}
}
