/*
 * @(#)DrawingView.java 5.1
 *
 */

package CH.ifa.draw.standard;

import CH.ifa.draw.framework.*;
import java.awt.image.ImageObserver;
import java.awt.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.util.*;

// A class that provides a drawing view that does nothing.
// Useful to erase fields that must not be null.

public class NullDrawingView implements DrawingView,
  ImageObserver, DrawingChangeListener
{
  private static Dimension nullDimension=new Dimension(0,0);
  private static Point nullPoint=new Point(0,0);

  public static NullDrawingView INSTANCE=new NullDrawingView();
  private NullDrawingView() {}

  public void setEditor(DrawingEditor editor) {}
  public Tool tool() {
    return NullTool.INSTANCE;
  }
  public Drawing drawing() {
    return NullDrawing.INSTANCE;
  }
  public void setDrawing(Drawing d) {}
  public DrawingEditor editor() {
    return NullDrawingEditor.INSTANCE;
  }
  public Figure add(Figure figure) {
    return figure;
  }
  public Figure remove(Figure figure) {
    return figure;
  }
  public void addAll(Vector figures) {}
  public Dimension getSize() {
    return nullDimension;
  }
  public Dimension getMinimumSize() {
    return nullDimension;
  }
  public Dimension getPreferredSize() {
    return nullDimension;
  }
  public void setDisplayUpdate(Painter updateStrategy) {}
  public Vector inZOrder(Vector figures) {
    return (Vector)figures.clone();
  }
  public Vector selection() {
    return new Vector();
  }
  public FigureEnumeration selectionElements() {
    return new FigureEnumerator(new Vector());
  }
  public Vector selectionZOrdered() {
    return new Vector();
  }
  public int selectionCount() {
    return 0;
  }
  public void addToSelection(Figure figure) {}
  public void addToSelectionAll(Vector figures) {}
  public void removeFromSelection(Figure figure) {}
  public void toggleSelection(Figure figure) {}
  public void clearSelection() {}
  public void selectionInvalidateHandles() { }
  public FigureSelection getFigureSelection() {
    return new FigureSelection(new Vector());
  }
  public Handle findHandle(int x, int y) {
    return null;
  }
  public Point lastClick() {
    return nullPoint;
  }
  public void setConstrainer(PointConstrainer p) {}
  public PointConstrainer getConstrainer() {
    return null;
  }
  public void checkDamage() {}
  public void repairDamage() {}
  public void paint(Graphics g) {}
  public Image createImage(int width, int height) {
    // Supposedly this method is only called by the update
    // strategy. But I do not call the update strategy and
    // nobody else is supposed to call it. Therefore it
    // should be safe to return a null. 
    return null;
  }
  public Graphics getGraphics() {
    return new NullGraphics();
  }
  public Color getBackground() {
    return Color.white;
  }
  public void setBackground(Color c) {}
  public void drawAll(Graphics g) {}
  public void invalidateHandles() {}
  public void drawHandles(Graphics g) {}
  public void drawDrawing(Graphics g) {}
  public void drawBackground(Graphics g) {}
  public void setCursor(Cursor c) {}
  public void freezeView() {}
  public void unfreezeView() {}
  public void moveSelection(int dx, int dy) {}
  public boolean imageUpdate(Image img, int inf, int x, int y, int w, int h) {
    return false;
  }
  public void drawingInvalidated(DrawingChangeEvent event) {}
  public void drawingRequestUpdate(DrawingChangeEvent event) {}
}
