package CH.ifa.draw.util;

import java.awt.*;
import java.util.*;

public interface ExtendedGraphics  {
 /** Additional Graphics methods, e.g. for drawing dashed lines. */

  /** Draws a dashed line starting at (x1,y1) and ending at (x2,y2)
   *  with the interval size strokeSize. That means a stroke of length
   *  strokeSize is followed by a gap of length strokeSize and so on.
   */
  public void drawDashedLine(int x1, int y1, int x2, int y2, int strokeSize);

 /* Draws a dashed Polyline (see drawDashedLine() and drawPolyline()).
  */
  public void drawDashedPolyline(int xPoints[], int yPoints[], int nPoints,
				 int strokeSize);

 /* Draws a dashed Polyline (see drawDashedLine() and drawPolyline()).
  */
  public void drawDashedPolyline(Vector points, int strokeSize);

}
