package de.renew.call;

import de.renew.simulator.*;
import de.renew.util.*;
import de.renew.unify.*;
import de.renew.expression.VariableMapper;
import collections.*;

class SynchronisationOccurrence implements Occurrence {
  SynchronisationRequest synchronisation;
  SynchronisationOccurrence(SynchronisationRequest synchronisation) {
    this.synchronisation=synchronisation;
  }

  public CollectionEnumeration makeExecutables(Copier copier) {
    // Remember the current settings of the parameters.
    // The parameters might not yet be complete due to
    // method calls during the action phase, but the
    // searcher decided that the tuple will be complete
    // before the executable gains control.
    Tuple copiedParameters=(Tuple)copier.copy(synchronisation.parameters);

    return new PairEnumeration(
      new NotifyExecutable(synchronisation,copiedParameters),
      new BlockExecutable(synchronisation));
  }

  /**
   * This provides access to my variable mapper.
   *
   * @return a variable mapper
   **/
  public VariableMapper getMapper() {
    return new VariableMapper();
  }
}
