package de.renew.expression;

import de.renew.unify.*;

public class ConstantExpression extends ExpressionWithTypeField {

  private Object constant;

  public ConstantExpression(Class targetType, Object constant) {
    super(targetType);
    this.constant=constant;
  }

  public Object getConstant() {
      return constant;
  }

  public boolean isInvertible() {
    // Because there is only one value that this expression
    // can take, there is really no use in starting a search
    // process.
    return false;
  }

  public Object startEvaluation(VariableMapper mapper, StateRecorder recorder, 
    CalculationChecker checker) throws Impossible
  {
    return constant;
  }

  public Object registerCalculation(VariableMapper mapper, 
    StateRecorder recorder, CalculationChecker checker) throws Impossible
  {
    return constant;
  }

  public String toString() {
    return "ConstantExpr("+de.renew.util.Types.typeToString(getType())+": "+constant+")";
  }
}
