package de.renew.formalism.fs;

import de.renew.shadow.*;
import de.uni_hamburg.fs.Name;
import de.uni_hamburg.fs.ParsedType;

public class ShadowAssoc extends ShadowInscribable {

  public static final int ZERO_OR_ONE=0;
  public static final int ZERO_OR_MORE=1;
  public static final int ONE_OR_MORE=2;

  private ShadowConcept concept,type;

  public ShadowAssoc(ShadowConcept concept, ShadowConcept type) {
    super(concept.getNet());
    this.concept=concept;
    this.type=type;
  }

  public ShadowConcept getConcept() {
    return concept;
  }

  public ShadowConcept getType() {
    return type;
  }

  public int getMultiplicity() {
      java.util.Enumeration elemenum=elements();
      String feature=null;
      while (elemenum.hasMoreElements()) {
	  String inscr = ((ShadowInscription)elemenum.nextElement()).inscr.trim();
	  if ("*".equals(inscr) || "0..*".equals(inscr))
	      return ZERO_OR_MORE;
	  else if ("1..*".equals(inscr))
	      return ONE_OR_MORE;
      }
      return ZERO_OR_ONE;
  }

  public Name getFeature() {
      java.util.Enumeration elemenum=elements();
      String feature=null;
      boolean multi=false;
      while (elemenum.hasMoreElements() && feature==null) {
	  String inscr = ((ShadowInscription)elemenum.nextElement()).inscr.trim();
	  if (inscr.indexOf("*")>=0) {
	      multi=true;
	  } else if (inscr.indexOf("..")<0) {
	      feature=inscr;
	  }
      }
      if (feature==null) {
	  feature = type.getName();
	  int pos=feature.indexOf("::");
	  if (pos>=0)
	      feature=feature.substring(pos+2);
	  feature = feature.substring(0,1).toLowerCase()
	      +feature.substring(1);
	  if (multi)
	      feature+="s";
	  System.out.println("Concept "+concept.getName()+" gets default feature name "+feature);
      }
      return new Name(feature);
  }

  public void discard() {
    // is there anything else to do here?
  } 

}
