package de.renew.gui;

import java.awt.*;
import java.util.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import de.renew.simulator.*;
import de.renew.unify.Aggregate;
import de.renew.unify.List;
import de.renew.unify.ListEnumeration;
import collections.*;

public class AggregateFigure extends HorizontalCompositeFigure {

   public AggregateFigure(RenewMode mode, Aggregate aggregate,
			  boolean expanded) {
      addAggregate(mode,aggregate,expanded);
      layout();
   }

   private void addAggregate(RenewMode mode, Aggregate aggregate,
			     boolean expanded) {
      boolean isList=aggregate instanceof List;
      add(new TextFigure(isList ? "{" : "[",true));
      boolean first=true;
      Enumeration elems=aggregate.elements();
      while (elems.hasMoreElements()) {
	if (first) {
	  first=false;
	} else {
	  add(new TextFigure(",", true));
	}
	Object token=elems.nextElement();
	if (token instanceof Aggregate) {
	  addAggregate(mode,(Aggregate)token,expanded);
	} else {
	  Figure tokenFig=mode.getTokenFigure(token,expanded);
	  add(tokenFig);
	  if (token instanceof NetInstance) {
	    addClickHandle(new NetInstanceHandle(tokenFig,null,
						 (NetInstance)token));
	  }
	}
      }
      if (isList) {
	Object openTail=((ListEnumeration)elems).getOpenTail();
	if (openTail!=null) {
	  add(new TextFigure(":",true));
	  add(mode.getTokenFigure(openTail,expanded));
	}
      }
      add(new TextFigure(isList ? "}" : "]",true));
   }

}

