package de.renew.gui;

import de.renew.simulator.TransitionInstance;
import de.renew.simulator.Tracer;
import de.renew.simulator.LateExecutable;
import de.renew.unify.Impossible;

/**
 *
 *
 * BreakpointExecutable.java
 * Created: Wed May 31 11:45:02 2000
 * @author Michael Duvigneau
 *
 * @see BreakpointOccurrence
 * @see BreakpointInscription
 **/
class BreakpointExecutable implements LateExecutable  {

  private GlobalTransitionBreakpoint breakpoint;
  private TransitionInstance instance;

  BreakpointExecutable(GlobalTransitionBreakpoint breakpoint, TransitionInstance instance) {
    this.breakpoint = breakpoint;
    this.instance = instance;
  }

  /**
   * @return <code>TRACE</code>
   */
  public int phase() {
    return LateExecutable.TRACE;
  }

  /**
   * Hitting a breakpoint does hardly need any time.
   *
   * @return <code>false</code>
   */
  public boolean isLong() {
    return false;
  }

  /**
   * Notify the user that the breakpoint was hit.
   *
   * @exception    de.renew.unify.Impossible 
   *               never?
   */
  public void execute(Tracer tracer) throws Impossible {
    breakpoint.hit(instance);
  }
  
}
