package de.renew.gui;

import java.util.Enumeration;
import java.util.Hashtable;
import CH.ifa.draw.framework.*;
import de.renew.shadow.*;
import de.renew.simulator.*;

public class FigureLookup {
  
  private Hashtable map;

  public FigureLookup(Hashtable lookupMap) {
    if (lookupMap == null) {
      map = new Hashtable();
    } else {
      map = lookupMap;
    }
  }

  /*
   * The hierarchical lookup has to be organized like follows:
   * Hashtable mapping NetInstances to local lookup tables,
   * which are Hashtables mapping FiguresWithID to NetElements.
   **
  public FigureLookup(Hashtable hierarchicalLookup) {
    map = new Hashtable();
    Enumeration localMappings = hierarchicalLookup.elements();
    Hashtable localFigureMapping;
    Enumeration netElements;
    FigureWithID currentFigure;
    while (localMappings.hasMoreElements()) {
      localFigureMapping = (Hashtable)localMappings.nextElement();
      netElements = localFigureMapping.keys();
      while (netElements.hasMoreElements()) {
	currentFigure = (FigureWithID)netElements.nextElement();
	map.put(currentFigure, localFigureMapping.get(currentFigure));
      }
    }
  }
    */

  public Place get(PlaceFigure figure) {
    return (Place)map.get(figure);
  }

  public Transition get(TransitionFigure figure) { 
    return (Transition)map.get(figure);
  }

}
