package de.renew.gui;

import java.util.*;
import java.awt.Rectangle;
import CH.ifa.draw.standard.StandardDrawing;
import CH.ifa.draw.framework.Figure;
import de.renew.simulator.*;

public class TokenBagDrawing extends StandardDrawing {

  private static Hashtable drawingsByInstance = new Hashtable();

  private PlaceInstance placeInstance=null;
  private TokenBagFigure tokenBag;

  static TokenBagDrawing getTokenBagDrawing(RenewMode mode, PlaceInstance pi) {
    // forbid concurrent searches for instance drawings.
    synchronized (drawingsByInstance) {
      // find instance drawing:
      if (drawingsByInstance.containsKey(pi))
	return (TokenBagDrawing)drawingsByInstance.get(pi);
      else
	return new TokenBagDrawing(mode,pi);
    }
  }

  private TokenBagDrawing(RenewMode mode, PlaceInstance pi) {
      this.placeInstance = pi;
      drawingsByInstance.put(pi,this);
      setName(placeInstance.toString());

      tokenBag=new TokenBagFigure(mode,null,pi,PlaceFigure.EXPANDED_TOKENS);
      add(tokenBag);
  }

    /*
  private Figure nullIsTokenBag(Figure f) {
      if (f==null) return tokenBag; else return f;
  }

  public Figure findFigure(int x, int y) {
      return nullIsTokenBag(tokenBag.findFigure(x,y));
  }

  public Figure findFigure(Rectangle r) {
      return nullIsTokenBag(tokenBag.findFigure(r));
  }

  public Figure findFigureWithout(int x, int y, Figure without) {
      return nullIsTokenBag(tokenBag.findFigureWithout(x,y,without));
  }

  public Figure findFigure(Rectangle r, Figure without) {
      return nullIsTokenBag(tokenBag.findFigure(r,without));
  }

  public Figure findFigureInside(int x, int y) {
      return nullIsTokenBag(tokenBag.findFigureInside(x,y));
  }

  public Figure findFigureInsideWithout(int x, int y, Figure without) {
      return nullIsTokenBag(tokenBag.findFigureInsideWithout(x,y,without));
  }
    */

  public void release() {
    if (placeInstance != null) {
      drawingsByInstance.remove(placeInstance);
      placeInstance = null;
      tokenBag = null;
    }
    super.release();
  }

  public void setAttribute(String name, Object value) {
    tokenBag.setAttribute(name,value);
  }

  /**
   * Returns whether drawing has been modified since last save.
   */
  public boolean isModified() {
    return false;  // a TokenBagDrawing should not be saved!
  }

}

