package de.renew.gui;

import java.io.*;
import de.renew.shadow.ShadowCompiler;

// Present an abstract way of generating and parsing XML
// files. This interface allows us to compile the main
// part of Renew without referencing any XML parser
// libraries. Furthermore, we can easily swap XML file
// formats.
public interface XMLFormat {
  public boolean canExport();
  public boolean canImport();
  // Throw a general exception, so that no reference
  // to e.g. SAXException is required.
  public CPNDrawing parse(InputStream stream) throws Exception;
  public void write(OutputStream stream, CPNDrawing drawing,
		    ShadowCompiler compiler) throws Exception;
}
