/*
 * @(#)MariaMode.java 5.1
 *
 */

package de.renew.gui.maria;

import java.awt.*;
import java.io.PrintWriter;
import java.io.FileOutputStream;
import java.awt.event.*;
import java.util.Properties;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.application.DrawApplication;
import de.renew.gui.*;
import de.renew.shadow.ShadowCompiler;

public class MariaMode extends JavaMode {
  public final static String IMAGES="/de/renew/gui/maria/";

  public MariaMode() {}

  public ShadowCompiler getCompiler() {
    return new MariaCompiler();
  }

  public boolean wantAux() {
    return true;
  }
  
  public String getAuxFigureName() {
    return IMAGES+"MT";
  }

  public String getAuxToolName() {
    return "Type Tool";
  }
  
  public void createAdditionalMenus(CPNApplication editor, MenuBar mb) {
    modifyFileMenu(editor,
		   mb.getMenu(DrawApplication.FILE_MENU));
  }

  protected void modifyFileMenu(final CPNApplication editor, Menu menu) {
    menu.insert(editor.createMenuItem("Export to Maria...",
      new ActionListener() {
        public void actionPerformed(ActionEvent event) {
          promptExportMaria(editor);
        }
      }),
      menu.getItemCount()-4);
  }
  
  public void promptExportMaria(CPNApplication editor) {
    Drawing drawing=editor.drawing();
    if (drawing instanceof CPNDrawing) {
      editor.toolDone();
      String path = editor.getSavePath("Export to Maria...",
				       drawing.getName(),
				       new String[]{"pn"});
      if (path != null) {
	editor.getMode().getSimulation().buildAllShadows();
	try {
	  PrintWriter p = new PrintWriter(new FileOutputStream(path));
	  new de.renew.gui.maria.MariaExporter(p).
	    export(((CPNDrawing)drawing).getShadow());
	  p.close();
	} catch (Exception e) {
	  e.printStackTrace();
	  editor.showStatus(e.toString());
	}
      }
    } else {
      editor.showStatus("This drawing is not a net!");
    }
  }
  
  public Tool createPlaceTool(DrawingEditor editor) {
    return new MariaPlaceCreationTool(editor);
  }
  
  public Tool createTransitionTool(DrawingEditor editor) {
    return new MariaTransitionCreationTool(editor);
  }
}

