package de.renew.remote;

import java.rmi.*;
import java.rmi.server.*;

import de.renew.simulator.Place;

/**
 * This class implements the <code>PlaceAccessor</code> interface
 * and nothing more.
 * <p>
 * </p>
 * PlaceAccessorImpl.java
 * Created: Fri Jul 14  2000
 * @author Michael Duvigneau
 */

public class PlaceAccessorImpl extends UnicastRemoteObject implements PlaceAccessor  {
  
  /**
   * The place that is accessible by this Accessor.
   */
  private Place place;


  /**
   * Creates a new place accessor for the given place.
   *
   * @param place the place to access
   * @exception java.rmi.RemoteException if an RMI failure occured.
   */  
  public PlaceAccessorImpl(Place place) throws RemoteException {
    super();
    this.place = place;
  }

  /* This method is specified by the Accessor interface. */
  public String asString() throws RemoteException {
    return place.toString();
  }

  /* This method is specified by the PlaceAccessor interface. */
  public int getID() throws RemoteException {
    return place.getID();
  }
} 
