package de.renew.shadow;

import collections.*;
import java.util.Hashtable;

public class ShadowNet implements java.io.Serializable {
  static final long serialVersionUID = 5180248532101141648L;

  public transient Object context=null;

  private UpdatableSet elements;
  private String name;
  ShadowNetSystem netSystem;

  public ShadowNet(String name, ShadowNetSystem netSystem) {
    elements=new HashedSet();
    this.name=name;
    this.netSystem=netSystem;
    netSystem.add(this);
  }

  public void setName(String name) {
    this.name=name;
  }
  public String getName() {
    return name;
  }
  public CollectionEnumeration elements() {
    return elements.elements();
  }

  public void discard() {
    netSystem.remove(this);
  }

  void add(ShadowNetElement element) {
    elements.include(element);
  }
  void remove(ShadowNetElement element) {
    elements.exclude(element);
    element.context=null;
  }
}

