package de.renew.simulator;

import collections.*;
import de.renew.unify.*;

class ArcAssignBinder extends AssignBinder {
  private PlaceInstance placeInstance;
  private boolean wantTest;
  
  public ArcAssignBinder(Variable variable, PlaceInstance placeInstance,
			 boolean wantTest)
  {
    super(variable,false);
    this.placeInstance=placeInstance;
    this.wantTest=wantTest;
  }
  
  public CollectionEnumeration getCandidates(Object pattern) {
    if (wantTest) {
      return placeInstance.getDistinctTestableTokens(pattern);
    } else {
      return placeInstance.getDistinctTokens(pattern);
    }
  }
  
  public TriggerableCollection getTriggerables() {
    return placeInstance.triggerables();
  }
}
