package de.renew.simulator;

public interface Binder {
  /**
   * Returns roughly the number of possible bindings to test.
   * Sometimes the searcher parameter ought to be
   * removed. It is unneccessary.
   **/
  public int bindingBadness(Searcher searcher); 

  /** 
   * Loop through all the possible bindings: <ul>
   * <li>  establish the binding,            </li>
   * <li>  remove this binder if it does not need to be accessed again, </li>
   * <li>  add other binders if required,    </li>
   * <li>  bind variables,                   </li>
   * <li>  call the searcher and             </li>
   * <li>  undo the bindings.                </li>
   * </ul>
   **/
  public void bind(Searcher searcher);
}

