package de.renew.simulator;

import de.renew.expression.*;
import collections.*;
import de.renew.unify.*;
import de.renew.util.*;

class ClearArcOccurrence implements InscriptionOccurrence {
  PlaceInstance placeInstance;
  VariableMapper mapper;
  Variable variable;
  ClearArc arc;

  ClearArcOccurrence(ClearArc arc, VariableMapper mapper,
    NetInstance netInstance)
  {
    this.arc=arc;
    this.mapper=mapper;
    placeInstance=netInstance.getInstance(arc.place);
  }

  public CollectionEnumeration makeBinders(Searcher searcher)
    throws Impossible 
  {
    variable=new Variable(
      arc.expression.startEvaluation(mapper,searcher.recorder,
        searcher.calcChecker),
      searcher.recorder);

    searcher.calcChecker.addCalculated(arc.expression.getType(),variable,null,
      searcher.recorder);
    return new EmptyEnumeration();
  }

  public CollectionEnumeration makeExecutables(Copier copier,
    VariableMapper copiedMapper)
  {
    Variable copiedVariable=(Variable)copier.copy(variable);

    return new SingletonEnumeration(
      new ClearArcExecutable(placeInstance,copiedVariable,arc));
  }
}
