package de.renew.simulator;

import de.renew.expression.*;
import de.renew.unify.*;

public class ExpressionTokenSource implements TokenSource {
  private Expression expression;
  private boolean trace;

  public ExpressionTokenSource(Expression expression) {
    this.expression=expression;
    trace=true;
  }

  public void setTrace(boolean trace) {
    this.trace=trace;
  }

  public boolean getTrace() {
    return trace;
  }

  public Object createToken(VariableMapper mapper) throws Impossible {
    Object value=expression.startEvaluation(mapper,
      new StateRecorder(),
      null);
    if (!Unify.isBound(value)) {
      throw new Impossible();
    }
    return value;
  }
}
