package de.renew.simulator;

import de.renew.expression.*;
import collections.*;
import de.renew.function.Function;
import de.renew.util.SingletonEnumeration;

public class FlexibleArc implements TransitionInscription {
  // Only some of the arc types known from ordinary arcs are implemented
  // for flexible arcs so far.
  public static final int in=Arc.in;
  public static final int out=Arc.out;
  public static final int fastBoth=Arc.fastBoth;

  Place place;
  int arcType;
  Expression expression;
  Function forwardFunction;
  Function backwardFunction;
  boolean trace;

  public FlexibleArc(Place place, int arcType,
    Expression expression, Function forwardFunction, Function backwardFunction)
  {
    this.place=place;
    this.arcType=arcType;
    this.expression=expression;
    this.forwardFunction=forwardFunction;
    this.backwardFunction=backwardFunction;
    trace=true;
  }

  boolean isOutputArc() {
    return arcType==out;
  }

  public void setTrace(boolean trace) {
    this.trace=trace;
  }

  public boolean getTrace() {
    return trace;
  }

  public CollectionEnumeration makeOccurrences(VariableMapper mapper,
    NetInstance netInstance, Searcher searcher)
  {
    return new SingletonEnumeration(new FlexibleArcOccurrence(this,
      mapper,netInstance));
  }
}

