package de.renew.simulator;

import java.util.Hashtable;
import de.renew.util.Null;

class IDRegistry implements java.io.Serializable {
  private Hashtable table;

  IDRegistry() {
    table=new Hashtable();
  }

  IDCounter register(Object elem) {
    elem=Null.convert(elem);
    IDCounter counter=(IDCounter)table.get(elem);
    if (counter==null) {
      counter=new IDCounter(IDSource.createID());
      table.put(elem,counter);
    }
    return counter;
  }

  String getID(Object elem) {
    return register(elem).getID();
  }

  void reserve(Object elem) {
    register(elem).reserve();
  }

  void unreserve(Object elem) {
    register(elem).unreserve();
  }

  void possiblyDiscard(Object elem) {
    elem=Null.convert(elem);
    IDCounter counter=(IDCounter)table.get(elem);
    if (counter!=null && counter.isDiscardable()) {
      table.remove(elem);
    }
  }

  void setID(Object elem, String id) {
    elem=Null.convert(elem);
    IDCounter counter=(IDCounter)table.get(elem);
    if (counter==null) {
      table.put(elem,new IDCounter(id));
    } else if (!counter.getID().equals(id)) {
      throw new RuntimeException("ID already in use.");
    }
  }
}
