package de.renew.simulator;

import collections.*;
import de.renew.unify.Impossible;

public interface LateExecutable extends Executable {
  // List all phases that may occur.
  public final int START=-9999;
  public final int TRACE=0;
  public final int LATECONFIRM=1;
  public final int ACTION=2;
  public final int OUTPUT=3;
  public final int COMPLETION_NOTIFY=OUTPUT;
  public final int END=9999;

  /**
   * Get the phase during which this executable should execute.
   *
   * The late executables will be executed after all
   * early executables regardless of the phase. The phase
   * is local to late executables.
   **/
  int phase();

  /**
   * Returns true, if this executable might take a long time to
   * execute.
   **/
  boolean isLong();
}
