package de.renew.simulator;

import collections.*;
import de.renew.unify.*;
import de.renew.util.Value;

public class TestArcBinder extends ArcRemoveBinder {
  protected TestArcBinder(Variable variable,
		PlaceInstance placeInstance,
		TokenReserver reserver)
  {
    super(variable,placeInstance,reserver);
  }

  protected boolean mayBind() {
    return true;
  }
  protected boolean possible(Object token) {
    return reserver.containsTestableToken(placeInstance,token);
  }
  protected boolean remove(Object token) {
    return reserver.testToken(placeInstance,token);
  }

  protected void unremove(Object token) {
    reserver.untestToken(placeInstance,token);
  }
}
