package de.renew.unify;

import collections.*;

public class ListEnumeration implements CollectionEnumeration {
  private Object current;

  public ListEnumeration(List list) {
      current=list;
  }

  private static boolean hasMoreElements(Object list) {
    return list instanceof List && !((List)list).isNull();
  }

  public boolean hasMoreElements() {
    return hasMoreElements(current);
  }

  public Object nextElement() {
    List list=(List)current;
      // has to be a non-empty List, otherwise hasMoreElements()==false
    current=list.tail();
    return list.head();
  }

  public int numberOfRemainingElements() {
    int nore=0;
    Object list=current;
    for (nore=0; hasMoreElements(list); ++nore)
      list=((List)list).tail();
    return nore;
  }

  public boolean corrupted() {
      return false; // can we find out if list has been changed?
  }

  public Object getOpenTail() {
    if (hasMoreElements()) {
      throw new RuntimeException("getOpenTail() called before ListEnumeration was over.");
    }
    if (current instanceof List)
      return null;
    else
      return current;
  }

}
