package de.uni_hamburg.fs;

import collections.*;
import java.util.*;

public class Partition implements java.io.Serializable {
   private UpdatableSet concepts = new HashedSet();

   public Partition() {}

   public Partition(ConceptImpl con) {
      concepts.include(con);
      con.partitions.include(this);
   }

   public void union(Partition partition) throws TypeException {
      Enumeration concenum = partition.concepts();
      while (concenum.hasMoreElements()) {
         ConceptImpl con = (ConceptImpl)concenum.nextElement();
	 addConcept(con);
      }
   }

   public void addConcept(ConceptImpl newcon) throws TypeException {
      Enumeration concenum = concepts.elements();
      while (concenum.hasMoreElements()) {
         ConceptImpl con = (ConceptImpl)concenum.nextElement();
         if (con == newcon)
            return;
         if (con.isa(newcon) || newcon.isa(con))
            throw new TypeException();
      }
      concepts.include(newcon);
      newcon.partitions.include(this);
      //System.out.println("Partition after add: "+this);
   }

  public boolean containsConcept(ConceptImpl con) {
      return concepts.includes(con);
  }

   public Enumeration concepts() {
       return concepts.elements();
   }

  public String toString() {
    StringBuffer output = new StringBuffer();
    CollectionEnumeration concs = concepts.elements();
    for (int i = 1; concs.hasMoreElements(); ++i) {
      if (i > 1)
	output.append(',');
      ConceptImpl con = (ConceptImpl)concs.nextElement();
      output.append(con.getName());
    }
      return output.toString();
  }

  public boolean equals(Object that) {
      if (that instanceof Partition) {
	  return ((Partition)that).concepts.sameStructure(concepts);
      }
      return false;
  }

}
